local mod = ...



-- Assets
-------------------------------------------------------------------------------------
mod:registerAssetId("models/BrineSalt.fbx/Prefab/BrineSpringPart", "PREFAB_BRINESPRING")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/BrineProdPart", "PREFAB_BRINEPROD")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart", "PREFAB_SALTPROD")

mod:registerAssetId("models/BrineSalt.fbx/Materials/Material.RoofStraw", "ROOF_STRAW")
mod:override({
    Id = "ROOF_STRAW",
	BackFaceVisible = true,
	HasAlphaTest = true
})



-- Resource: Dirty Brine
-------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/brinedirty.png", "ICON_BRINE_DIRTY", "ATLAS_CELL")

-- mod:register({
	-- DataType = "RESOURCE",
	-- Id = "RESOURCE_BRINE_DIRTY",
	-- ResourceName = "RESOURCE_BRINE_DIRTY_NAME",
	-- Icon = "ICON_BRINE_DIRTY",
	-- -- ResourceTypeList = { "RESOURCE" },
	-- -- IsTradable = true,
	-- ResourceLayoutType = "CRATES",
	-- DisplayInInventory = false,
	-- -- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 }
-- })



-- Resource: Brine
-------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/brineclean.png", "ICON_BRINE", "ATLAS_CELL")

-- mod:register({
	-- DataType = "RESOURCE",
	-- Id = "RESOURCE_BRINE",
	-- ResourceName = "RESOURCE_BRINE_NAME",
	-- Icon = "ICON_BRINE",
	-- ResourceTypeList = { "GRANARY" },
	-- IsTradable = true,
	-- ResourceLayoutType = "CRATES",
	-- DisplayInInventory = true,
	-- -- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 }
-- })



-- Resource: Salt
-------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/salt.png", "ICON_SALT", "ATLAS_CELL")

-- mod:register({
	-- DataType = "RESOURCE",
	-- Id = "RESOURCE_SALT",
	-- ResourceName = "RESOURCE_SALT_NAME",
	-- Icon = "ICON_SALT",
	-- ResourceTypeList = { "GRANARY" },
	-- IsTradable = true,
	-- ResourceLayoutType = "CRATES",
	-- DisplayInInventory = true,
	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 }
-- })


-- Override Vanilla Bakery
------------------------------------------------------------------------------------
mod:override({
  Id = "BUILDING_FUNCTION_BAKERY",
  ResourceListNeeded = {
    Action = "APPEND",
    { Resource = "BV1_SALT", Quantity = 1 }
  },
  InputInventoryCapacity = {
	Action = "APPEND",
	{ Resource = "BV1_SALT", Quantity = 10 }
    },
})
	
	

-- mod:override({
  -- Id = "BV1_SALT",
  -- Icon = "ICON_SALT",
-- })



-- Monument: Salt & Brine
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_SALTWORKS",
	Name = "BUILDING_SALTWORKS_NAME",
	Description = "BUILDING_SALTWORKS_DESC",
	BuildingType = "FOOD_PRODUCTION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	IsEditable = true,
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_SALTWORKS_NAME",
			BuildingPartList = { 
				"BRINESPRING_PART",
				"BRINEPROD_PART",
				"SALTPROD_PART",
			}
		},		
    }
})



-- Building Part: Brine Spring
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BRINESPRING_PART",
	Name = "BRINESPRING_PART_NAME",
	Description = "BRINESPRING_PART_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BRINESPRING"
	},
	ConstructionVisual = "CV_SPRING",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 4.2, {0.5, -0.5}, 16 ), -- first number moves left and right, second moves up and down (with X forward)
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
        }
    },
	AssetBuildingFunction = "BUILDING_FUNCTION_BRINESPRING_PART",
	ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_BRINESPRING",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, -28 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 35.0
        },
    },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
			{ Resource = "PLANK", Quantity = 5 }
		}
	}
})



-- Building Function: Brine Spring -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_BRINESPRING_PART",
    Name = "BUILDING_FUNCTION_BRINESPRING_PART_NAME",
	ResourceGenerated = "BV1_BRINE_DIRTY",
	IsInfinite = true
})



-- Building Part: Brine Prod
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BRINEPROD_PART",
	Name = "BRINEPROD_PART_NAME",
	Description = "BRINEPROD_PART_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BRINEPROD"
	},
	ConstructionVisual = "CV_BRINEPROD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.2, 5.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_BRINEPROD_PART",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
			{ Resource = "PLANK", Quantity = 5 },
			-- { Resource = "RESOURCE_THATCH", Quantity = 2 }
		}
	}
})



-- Building Function: Brine Prod -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_BRINEPROD_PART",
    Name = "BUILDING_FUNCTION_BRINEPROD_PART_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_BRINE", 
        Behavior = "BEHAVIOR_WORK"
    },
	InputInventoryCapacity = {
			{ Resource = "BV1_BRINE_DIRTY", Quantity = 20 },
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 1 },
    },
	ResourceListNeeded = {
		{ Resource = "BV1_BRINE_DIRTY", Quantity = 2 },
	},
    ResourceProduced = {
		{ Resource = "BV1_BRINE", Quantity = 1 }
	}
})



-- Building Part: Salt Prod
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "SALTPROD_PART",
	Name = "SALTPROD_PART_NAME",
	Description = "SALTPROD_PART_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SALTPROD"
	},
	ConstructionVisual = "CV_SALTPROD",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5.5, 4.5}, {-2.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_SALTPROD_PART",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 4 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
			{ Resource = "PLANK", Quantity = 5 },
			-- { Resource = "RESOURCE_CLAY", Quantity = 4 },
			-- { Resource = "RESOURCE_THATCH", Quantity = 3 }
		}
	}
})



-- Building Function: Salt Prod -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SALTPROD_PART",
    Name = "BUILDING_FUNCTION_SALTPROD_PART_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SALT", 
        Behavior = "BEHAVIOR_WORK"
    },
	InputInventoryCapacity = {
			{ Resource = "BV1_BRINE", Quantity = 30 },
			{ Resource = "WOOD", Quantity = 15 },
    },
    UpkeepPerCapacity = {
		{ Resource = "GOLD_COINS", Quantity = 1 },
    },
	ResourceListNeeded = {
		{ Resource = "BV1_BRINE", Quantity = 2 },
		{ Resource = "WOOD", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "BV1_SALT", Quantity = 1 },
	}
})



-- Job: Brine Worker -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_BRINE",
	JobName = "JOB_BRINE_NAME",
	JobDescription = "JOB_BRINE_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 5, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		IdleAnimation = "GATHER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_BRINE"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_BRINE"
    }
})



-- Job: Salt Worker -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SALT",
	JobName = "JOB_SALT_NAME",
	JobDescription = "JOB_SALT_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			Model = "PREFAB_TOOL_DAIRY_FARMER_BUCKET",
			KeepObjectOnWalkCycle = false
		},
		IdleAnimation = "GLASSMELTER_MELTING"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SALT"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SALT"
    }
})



-- Paths: 
-------------------------------------------------------------------------------------
mod:registerAssetId("models/BrineSalt.fbx/Prefab/BrineSpringPart/PATH_A_1", "BRINESPRINGPART_PATHA")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/BrineProdPart/pathB", "BRINEPRODPART_PATHB")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/BrineProdPart/pathC", "BRINEPRODPART_PATHC")
-- mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/PATH_D_1", "SALTPRODPART_PATHD")
-- mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/PATH_E_1", "SALTPRODPART_PATHE")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/PATH_E_2", "SALTPRODPART_PATHDE")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/PATH_F_1", "SALTPRODPART_PATHF")

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineSpringPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "BRINESPRINGPART_PATHA" }
        },
    }
})

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineProdPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "BRINEPRODPART_PATHB" }
        },
		{
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "BRINEPRODPART_PATHC" }
        },
    }
})

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
      -- {
            -- PathType = BUILDING_PATH_TYPE.DEFAULT,
            -- WayPointList = { "SALTPRODPART_PATHD" }
        -- },
		-- {
            -- PathType = BUILDING_PATH_TYPE.DEFAULT,
            -- WayPointList = { "SALTPRODPART_PATHE" }
        -- },
		{
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "SALTPRODPART_PATHDE" }
        },  
		{
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "SALTPRODPART_PATHF" }
        },
    }
})



-- Particle Effects: 
-------------------------------------------------------------------------------------
mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterA", "VAPOUR_EMITTERA_PREFAB")

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SMOKE",
	IsPlaying = false,
	IsEmitting = false
})

mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterB", "VAPOUR_EMITTERB_PREFAB")

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterB", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/VapourEmitterB", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SMOKE",
	IsPlaying = false,
	IsEmitting = false
})

mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterA", "FIRE_EMITTERA_PREFAB")

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE",
	IsPlaying = false,
	IsEmitting = false
})

mod:registerAssetId("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterB", "FIRE_EMITTERB_PREFAB")

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterB", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/FireEmitterB", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE",
	IsPlaying = false,
	IsEmitting = false
})

mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{
			"VAPOUR_EMITTERA_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
		{
			"VAPOUR_EMITTERB_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
		{
			"FIRE_EMITTERA_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
		{
			"FIRE_EMITTERB_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
	}
})



-- Grounding
-----------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineSpringPart/Gstep", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineSpringPart/Gbucket", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbucket01", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbucket02", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbucket03", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbucket06", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbucket07", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gbigbarrel", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Gsaltbuckets", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Goven01", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/SaltProdPart/Goven02", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineProdPart/Gbucket04", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BrineSalt.fbx/Prefab/BrineProdPart/Gbucket05", {DataType = "COMP_GROUNDED"})



-- Construction Visual
-----------------------------------------------------------------------------------
mod:registerAssetId("models/BrineSalt.fbx/Prefab/CVSaltProd", "CV_SALTPROD")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/CVBrineProd", "CV_BRINEPROD")
mod:registerAssetId("models/BrineSalt.fbx/Prefab/CVSpring", "CV_SPRING")



